# $Revision: 1.98 $, $Date: 2003/12/04 13:51:26 $
#
# Conditional build
%bcond_without	tetex	# don't build documentation
%bcond_without	tc	# don't build tc program (it breaks static linkage)
%bcond_without	tc_esfq	# build tc without esfq support (requires patched headers)
%bcond_without	tc_wrr	# build tc without wrr support
%bcond_with	uClibc	# do some hacks to build with uClibc

# is it 2.2 not 2.4+?
%define		_kernel22	%(echo %{_kernel_ver} | grep -q '2\.[3-9]\.' ; echo $?)

Summary:	Utility to control Networking behavior in 2.2.X kernels
Summary(es):	Herramientas para encaminamiento avanzado y configuracin de interfaces de red
Summary(pl):	Narzdzie do kontrolowania Sieci w kernelach 2.2
Summary(pt_BR):	Ferramentas para roteamento avanado e configurao de interfaces de rede
Name:		iproute2
%define mainver	2.4.7
%define snapshot ss020116
Version:	%{mainver}.%{snapshot}
%define	_rel	13
Release:	%{_rel}@%{_kernel_ver_str}
License:	GPL
Vendor:		Alexey Kuznetsov <kuznet@ms2.inr.ac.ru>
Group:		Networking/Admin
Source0:	ftp://ftp.inr.ac.ru/ip-routing/%{name}-%{mainver}-now-%{snapshot}.tar.gz
# Source0-md5:	2c7e5f3a10e703745ecdc613f7a7d187
Source1:	%{name}-owl-man.tar.bz2
# Source1-md5:	cd4425df972a4ab001db31a5eb1c5da5
Patch0:		%{name}-make.patch
Patch1:		%{name}-no_libresolv.patch
Patch2:		%{name}-disable_arpd.patch
Patch3:		%{name}-uspace.patch
Patch4:		%{name}-diffserv-config.patch
Patch5:		%{name}-netlink.patch
Patch6:		%{name}-kernellast.patch
# uClibc hacks
Patch7:		%{name}-uClibc.patch
# 2.2-specific stuff
Patch8:		%{name}-fix-2_2.patch
Patch9:		%{name}-htb2_tc.patch
# 2.4-specific
Patch10:	htb3.6_tc.patch
Patch11:	%{name}-stats.patch
# extensions
Patch12:	wrr-iproute2-2.2.4.patch
Patch13:	%{name}-2.2.4-now-ss001007-esfq.diff
BuildRequires:	bison
%{?with_tetex:BuildRequires:	psutils}
%{?with_tetex:BuildRequires:	sgml-tools}
%{?with_tetex:BuildRequires:	tetex-dvips}
%{?with_tetex:BuildRequires:	tetex-latex}
#%{?with_tetex:BuildRequires:	tetex-tex-babel}
Obsoletes:	iproute
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir	/sbin
%define		_sysconfdir	/etc/iproute2

%description
Linux 2.2 maintains compatibility with the basic configuration
utilities of the network (ifconfig, route) but a new utility is
required to exploit the new characteristics and features of the
kernel. This package includes the new utilities.

%description -l es
Linux mantiene compatibilidad con los utilitarios estndares de
configuracin de la red, pero se necesitan nuevos utilitarios para
usar los recursos y caractersticas del nuevo ncleo. Este paquete
incluye los nuevos utilitarios.

%description -l pl
Ten pakiet zawiera programy pozwalajce na kontrol routingu i innych
aspektw dotyczcych sieci.

%description -l pt_BR
O Linux mantm compatibilidade com os utilitrios padro de
configurao da rede, mas novos utilitrios so necessrios para fazer
uso das caractersticas e recursos da nova kernel. This package
includes the new utilities.

%package -n libnetlink-devel
Summary:	Library for the netlink interface
Summary(pl):	Biblioteka do interfejsu netlink
Group:		Development/Libraries

%description -n libnetlink-devel
This library provides an interface for kernel-user netlink interface.

%description -n libnetlink-devel -l pl
Ta biblioteka udostpnia interfejs do interfejsu netlink midzy jdrem
a przestrzeni uytkownika.

%prep
%setup -q -n %{name} -a1
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%{?with_uClibc:%patch7 -p1}
%if %{_kernel22}
%patch8 -p1
%patch9 -p1
%else
%patch10 -p1
%patch11 -p1
%endif
%{?with_tc_wrr:%patch12 -p1}
%{?with_tc_esfq:%patch13 -p1}

%build
WRRDEF=""
%{?with_tc_wrr:grep -q tc_wrr_class_weight %{_kernelsrcdir}/include/linux/pkt_sched.h || WRRDEF="-DNEED_WRR_DEFS"}

%{__make} \
	CC="%{__cc}" \
	OPT="%{rpmcflags} ${WRRDEF}" \
	KERNEL_INCLUDE="%{_kernelsrcdir}/include" \
	%{!?with_tc:SUBDIRS="lib ip misc" LDFLAGS="%{rpmldflags}"}

%{?with_tetex:%{__make} -C doc}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},%{_sysconfdir},%{_mandir}/man8,%{_libdir},%{_includedir}}

install ip/{ip,rtmon,routel} %{?with_tc:tc/tc} misc/{rtacct,rtstat} $RPM_BUILD_ROOT%{_sbindir}
install etc/iproute2/rt_protos \
	etc/iproute2/rt_realms \
	etc/iproute2/rt_scopes \
	etc/iproute2/rt_tables \
	$RPM_BUILD_ROOT%{_sysconfdir}
install man/*	$RPM_BUILD_ROOT%{_mandir}/man8
install lib/libnetlink.a $RPM_BUILD_ROOT%{_libdir}
install include/libnetlink.h $RPM_BUILD_ROOT%{_includedir}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README README.iproute2+tc RELNOTES %{?with_tetex:doc/*.ps}
%attr(755,root,root) %{_sbindir}/*
%dir %{_sysconfdir}
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/*
%{_mandir}/man8/*

%files -n libnetlink-devel
%defattr(644,root,root,755)
%{_libdir}/lib*.a
%{_includedir}/*.h

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: iproute2.spec,v $
Revision 1.98  2003/12/04 13:51:26  qboosh
- don't override -Wl,-export-dynamic in tc LDFLAGS (if building with tc)

Revision 1.97  2003/12/02 14:22:50  ankry
- spaces -> tabs

Revision 1.96  2003/12/02 13:47:04  qboosh
- cleanups, removed obsolete label and latest patches, reordered the rest
- added netlink patch from RH (CAN-2003-0856 fix)
- added kernellast patch - workaround to avoid messing between kernel and glibc headers
- uClibc patch moved to bcond (evil hacks - adds including of private kernel headers)
- fixed build on patched headers containing WRR definitions
- rel 13

Revision 1.95  2003/11/16 17:43:26  krzak
- fixed _kernel24 definition

Revision 1.94  2003/11/03 09:43:05  arekm
- don't apply wrr patch when without wrr

Revision 1.93  2003/11/03 09:27:03  arekm
- wrr has now similar bcond as there is for efsq already

Revision 1.92  2003/10/27 11:50:31  arekm
- diffserv/userspace patches

Revision 1.91  2003/10/18 00:10:21  havner
- commented out patch100

Revision 1.90  2003/10/12 10:38:32  cieciwa
- added temporary workaround for kernel 2.6.0 - FOR TESTING cvs up iproute2.spec!

Revision 1.89  2003/09/30 14:52:39  qboosh
- back to proper OPT

Revision 1.88  2003/09/29 08:37:54  areq
- add patches from pepe@apollo.net.pl (build with 2.4.22)

Revision 1.87  2003/08/31 17:45:23  mmazur
- rel 11 for ac

Revision 1.86  2003/08/12 19:31:17  qboosh
- cosmetics, _without_tc_esfq bcond

Revision 1.85  2003/08/11 22:46:31  ankry
- cosmetics

Revision 1.84  2003/08/08 13:09:20  qboosh
- BR: tetex-tex-babel (BTS#686)

Revision 1.83  2003/07/15 14:29:27  arekm
- added esfq support, needs patched kernel

Revision 1.82  2003/05/28 12:59:11  malekith
- massive attack: source-md5

Revision 1.81  2003/05/25 11:00:52  malekith
- massive attack, adding Source-md5

Revision 1.80  2003/05/25 05:48:58  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.79  2003/05/22 23:25:23  malekith
- we don't need db-devel just for ip; bcond it

Revision 1.78  2003/05/20 15:37:57  qboosh
- BR: sgml-tools

Revision 1.77  2003/05/17 20:46:25  misiek
- BR: bison

Revision 1.76  2003/05/03 21:23:12  jack
- added missing BR
- if ( tetex >= 2 ) { BR: tetex-tex-babel } - how this shuld be written? ;)

Revision 1.75  2003/04/17 11:21:51  cieciwa
- updated vor version 020116.

Revision 1.74  2002/11/15 00:25:13  jack
- cosmetic

Revision 1.73  2002/10/30 13:35:11  qboosh
- pl description for libnetlink-devel

Revision 1.72  2002/10/28 07:48:45  jajcus
- libnetlink also packaged (as libnetlink-devel)

Revision 1.71  2002/10/18 11:41:53  qboosh
- added no_libresolv patch

Revision 1.70  2002/09/12 09:03:15  cieciwa
- release 10,
- added %{_kernel_ver_str} to release,
- added HTB 3.6 support.

Revision 1.69  2002/07/23 13:16:18  qboosh
- allow build wrr support without patched kernel headers on build host
- new %%doc

Revision 1.68  2002/07/23 08:33:37  cieciwa
- release 9,
- added support for WRR.

Revision 1.67  2002/05/11 18:30:35  kloczek
- merge translations from Conectiva.

Revision 1.66  2002/05/11 18:11:19  areq
- Release 8, STBR

Revision 1.65  2002/05/11 18:09:21  areq
- add man pages form Owl http://www.openwall.com/Owl/

Revision 1.64  2002/04/25 16:37:13  arturs
fixed a small typo

Revision 1.63  2002/04/12 14:59:45  qboosh
- LDFLAGS can be passed in such way only without tc
- release 7: rebuild with fixed tc

Revision 1.62  2002/04/07 01:01:48  kloczek
- release 6.

Revision 1.61  2002/03/29 20:34:36  filon
- typo in files

Revision 1.60  2002/03/13 19:19:27  kloczek
- cosmetics.

Revision 1.59  2002/03/08 15:54:27  malekith
- added --without tc bcond

Revision 1.58  2002/03/08 15:39:21  malekith
- added --without tetex bcond

Revision 1.57  2002/03/05 17:58:47  marcus
- removed uclibc stuff
- rel5.

Revision 1.56  2002/03/03 20:29:23  qboosh
- added part of htb2_2.2.17.diff to htb2_tc patch so iproute2 can be built
  with kernel-headers without htb2 patch

Revision 1.55  2002/02/28 20:49:12  newrom
- Added htb.patch for tc (QoS)
- STBR && /test

Revision 1.54  2002/02/22 23:29:04  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.53  2002/02/18 22:20:34  gotar
- %desc

Revision 1.52  2002/02/02 02:25:27  misiek
- added patch that fixes some things (like ip route get)
- use proper CC
- release 4

Revision 1.51  2002/01/21 17:47:28  malekith
- rel 3
- BOOT -> embed

Revision 1.50  2002/01/18 02:13:21  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.49  2001/12/10 21:03:28  qrczak
- iproute2-label.patch: fix ISO C violation
- Release 2

Revision 1.48  2001/10/28 22:12:10  blues
- added fix-2_2.patch - fixes building on 2.2 kernel (adds missing
  definitions)
STBR

Revision 1.47  2001/10/11 13:26:37  malekith
- removed %{BOOT: } from Path1 (builder has problems downloading it)
- removed -m386 from build flags

Revision 1.46  2001/08/23 17:31:36  filon
- removed -s from install -s, stripping is done by rpm

Revision 1.45  2001/08/19 20:26:27  saq
- use %%_kernelsrcdir

Revision 1.44  2001/08/07 14:02:19  baggins
- updated to 2.4.7-now-ss010803
- removed obsolete patches

Revision 1.43  2001/08/01 12:44:28  jajcus
- /etc/iproute2/* marked as %config(noreplace).

Revision 1.42  2001/06/09 10:30:55  klakier
- a little cleanup

Revision 1.41  2001/06/08 15:34:34  wiget
linux-devel-BOOT is dead, uClibc don't have symlinks to kernel includes :-(

Revision 1.40  2001/06/04 14:43:47  baggins
- added linux-2.4.5 patch (commented out)

Revision 1.39  2001/05/22 22:51:05  klakier
- added -m386 for BOOT

Revision 1.38  2001/05/02 00:42:08  qboosh
- adapterized and made spec %%debug ready or using %%rpm*flags macros

Revision 1.37  2001/04/24 02:41:44  kloczek
- release 3.

Revision 1.36  2001/04/23 16:45:38  wiget
typo

Revision 1.35  2001/04/15 13:08:57  klakier
- now it links against uClibc!
- combined several patches into one uClibc.patch

Revision 1.34  2001/04/15 07:54:58  klakier
- BOOT ip moved to /sbin

Revision 1.33  2001/04/14 17:41:00  klakier
- added BOOT package
  TODO link with uClibc (some linking porblems so far)

Revision 1.32  2001/01/25 20:03:24  misiek
Massive attack. We use -O0 instead -O flags while debug enabled.

Revision 1.31  2000/11/06 19:39:36  baggins
- release 2
- added ll_types patch

Revision 1.30  2000/10/10 18:16:02  kloczek
- ops .. next fix in %install.

Revision 1.29  2000/10/10 17:46:03  kloczek
- fix for proper install routel.

Revision 1.28  2000/10/10 17:19:28  kloczek
- typo.

Revision 1.27  2000/10/10 17:04:51  kloczek
- make %%{debug} ready.

Revision 1.26  2000/10/10 16:45:52  baggins
- changed version to include snapshot date

Revision 1.25  2000/10/08 02:46:53  baggins
- updated to ss001007

Revision 1.24  2000/06/09 07:23:03  kloczek
- added using %%{__make} macro.

Revision 1.23  2000/06/07 07:04:05  wiget
BuildRequires latex

Revision 1.22  2000/05/21 01:39:51  kloczek
- spec adapterized.

Revision 1.21  2000/05/09 20:29:58  wiget
ss000305

Revision 1.20  2000/05/05 15:05:59  mis
- Group: synced with PLD groups

Revision 1.19  2000/04/01 11:14:46  zagrodzki
- changed all BuildRoot definitons
- removed all applnkdir defs
- changed some prereqs/requires
- removed duplicate empty lines

Revision 1.18  2000/03/28 16:54:34  baggins
- translated kloczkish into english

Revision 1.17  2000/03/10 14:47:13  cieciwa
- fixed typo in %install part. [missing"%"]

Revision 1.16  2000/03/10 14:26:36  kloczek
- spec adapterized,
- more rpm macros.

Revision 1.15  2000/02/28 16:41:16  wiget
- new snapshot

Revision 1.14  2000/01/04 23:09:25  wiget
- Obsoletes: iproute (easy upgrade from RH)

Revision 1.13  1999/10/28 07:18:47  wiget
- upgrade to new snapshot

Revision 1.12  1999/09/03 16:32:17  misiek
- updated to 0824

Revision 1.11  1999/08/01 01:27:26  kloczek
- release 3,
- fix: move all binaries to %{_sbindir}.

Revision 1.10  1999/07/28 16:25:45  kloczek
- added to BuildRequires psutils.

Revision 1.9  1999/07/27 21:28:05  kloczek
- typo in header.

Revision 1.8  1999/07/27 10:48:38  kloczek
- relaease 2,
- added BuildRequire: tetex-dvips.

Revision 1.7  1999/07/18 14:53:23  baggins
- fixed bogus Group: field

Revision 1.6  1999/07/12 23:05:58  kloczek
- added using CVS keywords in %changelog (for automating them).

Revision 1.5  1999/07/11 17:16:01  misiek
update && make doc

* Sat May  1 1999 Piotr Czerwiski <pius@pld.org.pl>
  [2.2.4-1]
- new upstream release (990417),
- patches corrected,
- added %{_sysconfdir}/iproute2/*,
- added more documentation,
- recompiled on rpm 3,
- cosmetic changes for common l&f.

* Fri Feb 19 1999 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
- new upstream release
- gzipping instead bzipping

* Fri Jan 01 1999 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
- new upstream release (981220).
- docs are now compressed

* Sat Nov 07 1998 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
- new upstream release (981101),
- corrected patch.

* Wed Oct 14 1998 Arkadiusz Mikiewicz <misiek@zsz2.starachowice.pl>
- initial rpm release.
